// Copyright 2007 Tapio Auvinen, Erik Fallenius, Ville Karavirta,
// Jussi Nikander, and Harri Salonen
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package cexer;

/**
 * An Option holds a numeric value and a boolean telling wether this Option has
 * been selected or not. Options are required when using the Select and Option
 * tapestry components. It should not be used elsewhere.
 */

public class Option {

    private boolean selected;
    private Integer label;

    public Option(boolean b, Integer s) {
	selected = b;
	label = s;
    }

    public void setSelected(boolean b) {
	selected = b;
    }

    public boolean getSelected() {
	return selected; 
    }

    public void setLabel(Integer s) {
	label = s;
    }

    public Integer getLabel() {
	return label;
    }

}
