// Copyright 2007 Tapio Auvinen, Erik Fallenius, Ville Karavirta,
// Jussi Nikander, and Harri Salonen
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package cexer.components;

import java.util.List;

import org.apache.tapestry.BaseComponent;
import org.apache.tapestry.IRequestCycle;

import cexer.Course;
import cexer.DataStorage;
import cexer.MonitorSession;
import cexer.util.CourseSelectionModel;


public abstract class CourseChange extends BaseComponent {

    public abstract MonitorSession getMonitorSession();

    public boolean isManyCourses() {
        return (getCourses().getOptionCount() > 1);
    }

    public void showCourse(IRequestCycle cycle) {
        cycle.activate(getPage());
    }

    public CourseSelectionModel getCourses() {
        List clist = getMonitorSession().getStudent().getCourseList();
        return new CourseSelectionModel(clist,getPage().getLocale().getLanguage());
    }

    public Course getCourse() {
        return getMonitorSession().getCourse();
    }

    public void setCourse(Course c) {
        getMonitorSession().setCourse(c);
        getMonitorSession().getMonitor().setDefaultCourse(c);
        DataStorage.getInstance().setStudentDefaultCourse(getMonitorSession().getMonitor().getId(), getCourse().getId());
    }

}
