// Copyright 2007 Tapio Auvinen, Erik Fallenius, Ville Karavirta,
// Jussi Nikander, and Harri Salonen
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package cexer.components;

import cexer.*;

import org.apache.tapestry.BaseComponent;
import org.apache.tapestry.IRequestCycle;
import java.util.Arrays;

import java.util.List;
import java.util.LinkedList;

public abstract class CourseStudents extends BaseComponent {

    private Course course;
    private Round round;
    private List studentResults;

    public abstract MonitorSession getMonitorSession();

    public abstract String getRowStyle1();
    public abstract String getRowStyle2();
    public abstract int getIndex();

    public String getRowStyle() {
        if((getIndex() % 2)==1)
            return getRowStyle2();
        else return getRowStyle1();
    }
    
    public Course getCourse() {
	return course;
    }

    public void setCourse(Course c) {
        if(getCourse() != c)
            setStudentResults(null);
	course = c;
    }

    public Round getRound() {
	return round;
    }

    public void setRound(Round c) {
	round = c;
    }

    public abstract Student getStudent();

    public int getResult() {
	return getStudent().getRoundResult(getCourse(),getRound().getRoundNumber());
    }

    public int getTotal() {
	return getStudent().getCourseResult(getCourse());
    }

    public String getGrade() {
	return getStudent().getGrade(getCourse());
    }
    
    public boolean isInstructor() {
        return getStudent().isInstructor() || getStudent().isAdmin();
    }

    public boolean getHasName() {
        return getStudent().getName() != null && !getStudent().getName().equals("null");
    }
    
    public boolean getHasEmail() {
        return getStudent().getEmail() != null && !getStudent().getEmail().equals("null");
    }

    /*
    public List getStudentResults() {
	return studentResults;
    }
*/
    public List getStudentResults() {
        return getMonitorSession().getStudentResults();
        /*
        if(studentResults == null) {
            setStudentResults(getMonitorSession().getStudentResults());
            
        }
        else return studentResults; */
    }
        
    public void setStudentResults(List results) {
	studentResults = results;
    }


 //   public abstract List getStudentResults();
 //   public abstract void setStudentResults(List studentResults);
    
    
    public List getResults() {
	return getStudentResults();
    }

    public void setResults(List results) {
	setStudentResults(results);
    }
    
    public void sortResultsByName(IRequestCycle cycle) {
        Object[] temp = getStudentResults().toArray();
        Arrays.sort(temp);
        List sortedList = Arrays.asList(temp);
        setStudentResults(sortedList);
        cycle.activate(getPage());
    }

    public void studentInfoAction(IRequestCycle cycle) {
    Object[] params = cycle.getListenerParameters();
    Student tempStudent = (Student)getStudentResults().get(((Integer)params[0]).intValue());
    DataStorage ds = DataStorage.getInstance();
    //Get a real student from the database, as the studentresult list objects don't contain all the result data
    Student student = ds.getStudent(tempStudent.getId()); 
	getMonitorSession().setMonitoredStudent(student);
	cycle.activate("MonitorStudent");
    }


}
