// Copyright 2007 Tapio Auvinen, Erik Fallenius, Ville Karavirta,
// Jussi Nikander, and Harri Salonen
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package cexer.pages;

import java.util.Iterator;
import java.util.List;
import java.util.LinkedList;
import java.util.ListIterator;

import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.form.IPropertySelectionModel;
import org.apache.tapestry.valid.ValidationDelegate;
import cexer.*;
import cexer.util.Checker;
import cexer.util.CourseSelectionModel;
import cexer.util.Logging;

public class CourseRegisterPage extends NormalPage {

    private Course course;

    public void setCourse(Course c) {
	course = c;
    }

    public Course getCourse() {
	return course;
    }

    public void setCourses(CourseSelectionModel value) {
	// do nothing
    }

    public CourseSelectionModel getCourses() {
        // TODO: Remove courses that the student is already in
	    List l = DataStorage.getInstance().getCourseSelectionModel().getList();
        List sl = ((Visit)getVisit()).getStudent().getCourseList();
        Iterator it = sl.iterator();
        while (it.hasNext()) {
            Course c = (Course) it.next();
            l.remove(c);            
        }
        return new CourseSelectionModel(l);
    }

    public void formSubmit(IRequestCycle cycle) {
	Visit visit = (Visit) getVisit();
	visit.setWarning(false);
	ValidationDelegate delegate = (ValidationDelegate)getBeans().getBean("delegate");
	if (delegate.getHasErrors()) {
	    cycle.activate(this);
	    return;
	}
    if (getCourse() == null) {
        visit.setWarning(true);
        visit.setWarningText("No course selected.");
        cycle.activate("Settings");
        return;
    }
	String studentNumber = visit.getUsername().toUpperCase();
	String checker = getCourse().getCheckerClass();
	if(Checker.check(studentNumber, checker)) {
	    Student student = visit.getStudent();
	    List courses = student.getCourseList();
	    if(courses.indexOf(getCourse()) < 0) {
		DataStorage ds = DataStorage.getInstance();
		// 2005 EXPERIMENT HACK BEGINS //
		if (getCourse().getId() == 998) {
		    int lastNum = Integer.parseInt(studentNumber.substring(4, 5));
		    if (lastNum%2 == 1) {
			setCourse(ds.getCourse(999));
		    }
		}
		// 2005 EXPERIMENT HACK ENDS //
		student.addCourse(getCourse());
		ds.registerStudentToCourse(studentNumber, getCourse().getId());
	    }
        visit.setWarning(true);
        visit.setWarningText("Registration added for course " +
                             getCourse().getCourseCode());       
	    cycle.activate("Settings");
	} else {
        visit.setWarning(true);
	    visit.setWarningText("Invalid student number for the course " +
                             getCourse().getCourseCode());
	    cycle.activate("Settings");
	}
    }

}
