// Copyright 2007 Tapio Auvinen, Erik Fallenius, Ville Karavirta,
// Jussi Nikander, and Harri Salonen
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package cexer.pages;

import org.apache.tapestry.IBinding;
import org.apache.tapestry.html.BasePage;

/** This page needs two parameters given as service parameters before 
  activation. First, the name of the page to redirect to, and second, 
  the name of the context, i.e. app or monitor. */
public class LanguageChangePage extends BasePage {
    public String getRefreshUrl() {
	String ret = "0;URL=http://";
	//make sure properties are loaded
	cexer.DataStorage.getInstance();
	String server = System.getProperty("http.server");
	if(server == null) {
	    //server = "trakla.cs.hut.fi";
	    server = "";
	}
	ret = ret + server + "/" + getRequestCycle().getListenerParameters()[1] + "?service=page&page=";
	return ret + getPrevPage();
    }

    public String getPrevPage() {
	return getRequestCycle().getListenerParameters()[0].toString();
    }
}
