// Copyright 2007 Tapio Auvinen, Erik Fallenius, Ville Karavirta,
// Jussi Nikander, and Harri Salonen
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package cexer.pages;

import java.util.Iterator;

import org.apache.tapestry.IRequestCycle;
import cexer.*;

public abstract class MonitorAllExercisesPage extends SecurePage {

    public abstract MonitorSession getMonitorSession();
    
    public void testExercise(IRequestCycle cycle) {
        MonitorSession session = getMonitorSession();
        Object[] params = cycle.getListenerParameters();
        Exercise tempExercise = (Exercise)session.getRound().getExerciseList().get(((Integer)params[0]).intValue());
        session.setExercise(tempExercise);
        cycle.activate("MonitorTestExercise");
    }

    public abstract String getRowStyle1();
    public abstract String getRowStyle2();
    public abstract int getIndex();
    public abstract Exercise getExercise();
    
    public String getRowStyle() {
        if((getIndex() % 2)==1)
            return getRowStyle2();
        else return getRowStyle1();
    }
    
    public String getExerciseName() {
        return getExercise().getLocalizedName(getLocale().getLanguage());
    }
    
    public String getLocales() {
        Iterator locales = getExercise().getSupportedLocales().iterator();
        String ret = "";
        while(locales.hasNext()) {
            ret = ret + locales.next() + " ";
        }
        return ret;
    }

    public boolean getHasNewDescription() {
        if(getExercise().getTask().equals(""))
            return false;
        return true;
    }
    
    public boolean getHasPseudocode() {
        if(getExercise().getCodeBlockNames().size() > 0)
            return true;
        return false;
    }
}
