// Copyright 2007 Tapio Auvinen, Erik Fallenius, Ville Karavirta,
// Jussi Nikander, and Harri Salonen
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package cexer.pages;

import org.apache.tapestry.html.BasePage;
import org.apache.tapestry.IRequestCycle;
import cexer.*;
import java.util.Iterator;

public class MonitorCourseInformationPage extends SecurePage {

    private Round round;
    private Exercise exercise;
    private String grade;
    private int minPoints;
    private int index;
    private int[] gradeMinPoints;

    public Round getRound() { return round; }
    public void setRound(Round value) { round = value; }
    public Exercise getExercise() { return exercise; }
    public void setExercise(Exercise value) { exercise = value; }

    public String getLocales() {
	Iterator locales = getExercise().getSupportedLocales().iterator();
  	String ret = "";
  	while(locales.hasNext()) {
  	    ret = ret + locales.next() + " ";
  	}
  	return ret;
    }

    public void testExercise(IRequestCycle cycle) {
	Visit v = (Visit)getVisit();
	//v.setCourse(getCourse());
	v.setRound(getRound());
	v.setExercise(getExercise());
	cycle.activate("MonitorTestExercise");
    }

    public String getExerciseName() {
	return getExercise().getLocalizedName(getLocale().getLanguage());
    }

    public String getExerciseDescription() {
	return getExercise().getLocalizedDescription(getLocale().getLanguage());
    }

    public void detach() {
	super.detach();
	round = null;
	exercise = null;
    }

    public void setIndex(int i) {
	index = i;
    }

    public int[] getGradeMinPoints() {
	gradeMinPoints = ((Visit)getVisit()).getCourse().getGradeMinPoints();
	return gradeMinPoints;
    }

    public int getIndex() {
	return index;
    }

    public String getPoints() {
	if(index < gradeMinPoints.length - 1) {
	    return gradeMinPoints[index] + " - " + gradeMinPoints[index+1];
	}
	else { 
	    return gradeMinPoints[index] + " - " + ((Visit)getVisit()).getCourse().getMax();
	}
    }

    public void setMinPoints(int p) {
	minPoints = p;
    }

    public int getMinPoints() {
	return minPoints;
    }

    public void setGrade(String s) {
	grade = s;
    }

    public String getGrade() {
	Visit v = (Visit)getVisit();
	return v.getCourse().getGrade(minPoints);
    }

}
