// Copyright 2007 Tapio Auvinen, Erik Fallenius, Ville Karavirta,
// Jussi Nikander, and Harri Salonen
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package cexer.pages;

import org.apache.tapestry.html.BasePage;
import org.apache.tapestry.IRequestCycle;
import cexer.*;
import cexer.util.Logging;

import java.util.List;

public abstract class MonitorTextResultsPage extends SecurePage {

    public abstract MonitorSession getMonitorSession();

    public abstract void setStudentResults(List l);
    public abstract List getStudentResults();

    public String getCourseResults() {
        String res = "id\t";

        Logging.info(this, "getCourseResults()");

        MonitorSession session = getMonitorSession();
        Course c = session.getCourse();
        int nroRounds = session.getCourse().getRoundList().size();

        for(int i = 1; i < nroRounds+1; i++) {
            res += i + "\t";
        }

        res += "total\tgrade\n";

        Logging.info(this, "calling getStudentResults()");
        List stu = getStudentResults();

        for (int i = 0; i < stu.size(); i++) {
            Student s = (Student) stu.get(i);

            res += s.getStudentNumber() + "\t";
            List rounds = session.getCourse().getRoundList();

            for(int j = 0; j < rounds.size(); j++) {
                Round r = (Round)rounds.get(j);
                res += s.getRoundResult(c,r.getRoundNumber())+"\t";
            }
            res += s.getCourseResult(c) + "\t";

            if (s.isUnregistered()) {
                res += s.getGrade(c) + " (unregistered)\n";
            } else {
                res += s.getGrade(c) + "\n";
            }
        }

        return res;
    }

}
