// Copyright 2007 Tapio Auvinen, Erik Fallenius, Ville Karavirta,
// Jussi Nikander, and Harri Salonen
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package cexer.pages;

import org.apache.tapestry.html.BasePage;
import org.apache.tapestry.IRequestCycle;
import cexer.DataStorage;
import cexer.Visit;

public class SecurePage extends BasePage {

    public void validate(IRequestCycle cycle) {
	super.validate(cycle);
	//v3: String url = cycle.getRequestContext().getAbsoluteURL(cycle.getRequestContext().getRequestURI());
    String url = cycle.getAbsoluteURL(cycle.getInfrastructure().getRequest().getRequestURI());
	if (url.startsWith("http:")) {
	    //make sure DataStorage properties are loaded
	    DataStorage.getInstance();
	    //v3: String appl = cycle.getRequestContext().getRequestURI();
        String appl = cycle.getInfrastructure().getRequest().getRequestURI();
        if(appl.startsWith("/monitor")) {
		appl = "/monitor";
	    } else {
		appl = "/app";
	    }
	    throw new org.apache.tapestry.RedirectException("https://" + System.getProperty("https.server") + appl + "?service=page&page=" + getPageName());
	}
    }

    public String getInsufficientAccess() {
	Visit visit = (Visit) getVisit();
	cexer.util.Logging.info("User " + visit.getUsername() + " tried to access page " + 
				getPageName() + " with insufficient access rights.");
	return "No access.";
    }

}
