// Copyright 2007 Tapio Auvinen, Erik Fallenius, Ville Karavirta,
// Jussi Nikander, and Harri Salonen
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package cexer.util;

import org.apache.log4j.Logger;

public class Logging extends Logger{

    private Logging(String name) {
	super(name);
    }

    private static Logger getLogger(Object loggingClass) {
	return Logger.getLogger(loggingClass.getClass());
    }

    public static void debug(String msg) {
	getLogger(new Logging("")).debug(msg);
    }

    public static void debug(Object loggingClass, String msg) {
	getLogger(loggingClass).debug(msg);
    }

    public static void debug(Object loggingClass, String msg, Throwable t) {
	getLogger(loggingClass).debug(msg, t);
    }

    public static void info(String msg) {
	getLogger(new Logging("")).info(msg);
    }

    public static void info(Object loggingClass, String msg) {
	getLogger(loggingClass).info(msg);
    }

    public static void info(Object loggingClass, String msg, Throwable t) {
	getLogger(loggingClass).info(msg, t);
    }

    public static void warn(String msg) {
	getLogger(new Logging("")).warn(msg);
    }

    public static void warn(Object loggingClass, String msg) {
	getLogger(loggingClass).warn(msg);
    }

    public static void warn(Object loggingClass, String msg, Throwable t) {
	getLogger(loggingClass).warn(msg, t);
    }

    public static void error(String msg) {
	getLogger(new Logging("")).error(msg);
    }

    public static void error(Object loggingClass, String msg) {
	getLogger(loggingClass).error(msg);
    }

    public static void error(Object loggingClass, String msg, Throwable t) {
	getLogger(loggingClass).error(msg, t);
    }

    public static void fatal(String msg) {
	getLogger(new Logging("")).fatal(msg);
    }

    public static void fatal(Object loggingClass, String msg) {
	getLogger(loggingClass).fatal(msg);
    }

    public static void fatal(Object loggingClass, String msg, Throwable t) {
	getLogger(loggingClass).fatal(msg, t);
    }
}
