// Copyright 2007 Tapio Auvinen, Erik Fallenius, Ville Karavirta,
// Jussi Nikander, and Harri Salonen
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package cexer.util;

import java.util.List;

import org.apache.tapestry.form.IPropertySelectionModel;
import cexer.ExerciseTemplate;

public class TemplateSelectionModel implements IPropertySelectionModel {

    private List templates;

    public TemplateSelectionModel(List templates) {
	this.templates = templates;
    }

    public String getLabel(int index) {
	return ((ExerciseTemplate)templates.get(index)).getName();
    }
    
    public Object getOption(int index) {
	return templates.get(index);
    }

    public int getOptionCount() {
	return templates.size();
    }

    public String getValue(int index) {
	return Integer.toString(index);
    }

    public Object translateValue(String value) {
	return getOption(Integer.parseInt(value));
    }

}
